fleet/urls.py
from django.contrib import auth
from django.urls import path

from . import views

urlpatterns = [
    path(
        "",
        views.MapsView.as_view(),
        name="maps",
    ),
    path(
        "issues/",
        views.IssueListView.as_view(),
        name="issues",
    ),
    path(
        "room/<slug:slug>/map",
        views.RoomMapView.as_view(),
        name="room_map",
    ),
    path(
        "sessions/",
        views.SessionListView.as_view(),
        name="sessions",
    ),
    path(
        "user/<str:username>/sessions/history",
        views.UserSessionHistoryView.as_view(),
        name="user_session_history",
    ),
    path(
        "user/<str:username>",
        views.UserProfileView.as_view(),
        name="user_profile",
    ),
    path(
        "user/<str:username>/issues",
        views.IssueListView.as_view(),
        name="user_issues",
    ),
    path(
        "login",
        auth.views.LoginView.as_view(),
        name="login",
    ),
    path(
        "logout",
        auth.views.LogoutView.as_view(),
        name="logout",
    ),
    path(
        "workstations/<int:pk>",
        views.WorkstationDetailView.as_view(),
        name="workstation_detail",
    ),
    path(
        "workstations/<int:workstation_pk>/issue/create",
        views.WorkstationIssueCreateFormView.as_view(),
        name="workstation_issue_create",
    ),
    path(
        "workstations/<int:workstation_pk>/issue/<int:pk>/update",
        views.WorkstationIssueUpdateFormView.as_view(),
        name="workstation_issue_update",
    ),
    path(
        "workstations/<int:workstation_pk>/issue/<int:pk>/reject",
        views.WorkstationIssueRejectView.as_view(),
        name="workstation_issue_reject",
    ),
    path(
        "workstations/<int:workstation_pk>/issue/<int:pk>/resolve",
        views.WorkstationIssueResolveView.as_view(),
        name="workstation_issue_resolve",
    ),
]

fleet_manager/urls.py
from django.conf import settings
from django.contrib import admin
from django.urls import include, path
from drf_spectacular.views import (
    SpectacularAPIView,
    SpectacularRedocView,
    SpectacularSwaggerView,
)
from rest_framework.decorators import api_view
from rest_framework.response import Response
from rest_framework.reverse import reverse

apps_with_api = ("fleet", "salt", "sessions_state")


# pylint: disable=redefined-builtin
@api_view(["GET"])
def api_root(request, format=None):
    data = {}
    for app in apps_with_api:
        data[app] = reverse(f"{app}-api-root", request=request, format=format)
    return Response(data)


def crash(request):
    _ = 1 / 0


urlpatterns = [
    path("admin/", admin.site.urls),
    path("accounts/", include("django.contrib.auth.urls")),
    path("accounts/", include("social_django.urls", namespace="social")),
    path("pxe/", include("pxe.urls")),
    path("api/", api_root),
    path("api/crash/", crash),
    path("api/doc/", SpectacularAPIView.as_view(), name="schema"),
    path(
        "api/doc/swagger/",
        SpectacularSwaggerView.as_view(url_name="schema"),
        name="schema-swagger",
    ),
    path(
        "api/doc/redoc/",
        SpectacularRedocView.as_view(url_name="schema"),
        name="schema-redoc",
    ),
    path("", include("fleet.urls")),
] + [path(f"api/{app}/", include(f"{app}.api")) for app in apps_with_api]

if settings.DEBUG:
    import debug_toolbar

    urlpatterns = [path("__debug__/", include(debug_toolbar.urls))] + urlpatterns

pxe/urls.py
from django.urls import path

from .views import CheckEpitaUserAllowed, HTMLMenuView, IndexView, MenuView

urlpatterns = [
    path(r"menu/", MenuView.as_view(), name="menu"),
    path(r"menu/html/", HTMLMenuView.as_view(), name="htmlmenu"),
    path(r"menu/html/<int:pk>/<backstack>/", HTMLMenuView.as_view(), name="htmlmenu"),
    path(r"menu/html/<int:pk>/", HTMLMenuView.as_view(), name="htmlmenu"),
    path(r"", IndexView.as_view(), name="pxeindex"),
    path(
        r"epita-user-allowed/",
        CheckEpitaUserAllowed.as_view(),
        name="epita-user-allowed",
    ),
]

sessions_state/models.py
from datetime import timedelta

from django.contrib.postgres.fields import DateTimeRangeField
from django.db import models
from django.db.models import Q
from django.utils import timezone
from psycopg2.extras import DateTimeTZRange

from fleet.models import Workstation


class SessionBaseQuerySet(models.QuerySet):
    def by_room(self, room):
        return self.filter(
            ip__in=map(
                str, Workstation.objects.filter(room=room).values_list("ip", flat=True)
            )
        )

    def latest_by_login(self):
        latest_ids = []
        for login in set(self.values_list("login", flat=True)):
            latest_ids.append(self.filter(login=login).latest().id)
        return self.filter(id__in=latest_ids)


class SessionBase(models.Model):
    SESSION_TIMEOUT_SECONDS = 3 * 60

    id = models.BigAutoField(primary_key=True, unique=True)

    ip = models.CharField(max_length=255, db_index=True)

    login = models.CharField(max_length=255, db_index=True)

    image = models.CharField(max_length=255)

    objects = SessionBaseQuerySet.as_manager()

    @property
    def workstation(self):
        try:
            return Workstation.objects.get(ip=self.ip)
        except Workstation.DoesNotExist:
            return None

    class Meta:
        abstract = True


class SessionStateQuerySet(SessionBaseQuerySet):
    def current(self):
        timeout = timedelta(seconds=self.model.SESSION_TIMEOUT_SECONDS)
        return self.filter(timestamp__gte=timezone.now() - timeout)


class SessionState(SessionBase):
    timestamp = models.DateTimeField(db_index=True)

    locked = models.BooleanField(default=False)

    objects = SessionStateQuerySet.as_manager()

    class Meta:
        get_latest_by = "timestamp"
        ordering = ("-timestamp",)

    def __str__(self):
        return f"{self.timestamp} {self.ip} {self.login} {self.image}"

    def is_same_session(self, other):
        timeout = timedelta(seconds=self.SESSION_TIMEOUT_SECONDS)
        return all(
            (self.login == other.login, self.ip == other.ip, self.image == other.image)
        ) and any(
            (
                self.timestamp - timeout <= other.timestamp <= self.timestamp + timeout,
                other.timestamp - timeout
                <= self.timestamp
                <= other.timestamp + timeout,
            )
        )

    @classmethod
    def connected_users(cls):
        return cls.objects.filter(
            timestamp__gte=timezone.now()
            - timedelta(seconds=cls.SESSION_TIMEOUT_SECONDS)
        )


class Session(SessionBase):
    interval = DateTimeRangeField(db_index=True)

    class Meta:
        get_latest_by = "interval"
        ordering = ("-interval", "login")

    def __str__(self):
        return f"{self.interval} {self.ip} {self.login} {self.image}"

    def merge_session(self, other):
        self.interval = DateTimeTZRange(
            lower=min(self.interval.lower, other.interval.lower),
            upper=max(self.interval.upper, other.interval.upper),
        )

    @classmethod
    def prepare_merge_sessions(cls, sessions):
        timeout = timedelta(seconds=cls.SESSION_TIMEOUT_SECONDS)
        sessions_to_save = []

        for session in sessions:
            existing_sessions = cls.objects.filter(
                login=session.login,
                ip=session.ip,
                image=session.image,
            ).filter(
                Q(interval__contains=session.interval.lower - timeout)
                | Q(interval__contains=session.interval.upper + timeout),
            )

            if existing_sessions:
                existing_session = existing_sessions[0]
                existing_session.merge_session(session)
                session = existing_session

            sessions_to_save.append(session)

        return sessions_to_save

fleet/views.py
import logging
from xml.etree import ElementTree

from django.conf import settings
from django.contrib.auth import get_user_model
from django.contrib.auth.mixins import LoginRequiredMixin
from django.contrib.messages.views import SuccessMessageMixin, messages
from django.core.exceptions import ValidationError
from django.http import (
    Http404,
    HttpResponseForbidden,
    HttpResponseRedirect,
    JsonResponse,
)
from django.shortcuts import redirect, render
from django.template import Context, Engine
from django.urls import reverse, reverse_lazy
from django.utils.decorators import method_decorator
from django.views.decorators.csrf import csrf_exempt
from django.views.generic import (
    CreateView,
    DetailView,
    ListView,
    TemplateView,
    UpdateView,
    View,
)
from django.views.generic.detail import SingleObjectMixin
from django.views.generic.edit import ModelFormMixin
from django_filters import filters
from django_filters.rest_framework import FilterSet
from rest_framework.decorators import action
from rest_framework.permissions import DjangoModelPermissionsOrAnonReadOnly
from rest_framework.viewsets import ModelViewSet

from sessions_state.models import Session, SessionState

from .filters import IssueFilter
from .forms import IssueCreateForm, IssueForm, RegisterForm
from .models import DhcpSubnet, Issue, Machine, Room, Site, Workstation
from .permissions import DjangoModelWithViewPermissions
from .serializers import (
    IssueSerializer,
    MachineSerializer,
    RoomSerializer,
    SiteSerializer,
    WorkstationSerializer,
)

logger = logging.getLogger(__name__)


class DhcpConfigDiscovery(View):
    http_method_names = ("get",)

    def get(self, request, *args, **kwargs):
        if (
            "Kea-Shared-Secret" not in request.headers
            or request.headers["Kea-Shared-Secret"] != settings.KEA_SHARED_SECRET
        ):
            return HttpResponseForbidden("Kea-Shared-Secret missing or invalid.")

        dhcp_config = {
            "Dhcp4": {
                "valid-lifetime": settings.DHCP_VALID_LIFETIME,
                "min-valid-lifetime": settings.DHCP_MIN_VALID_LIFETIME,
                "max-valid-lifetime": settings.DHCP_MAX_VALID_LIFETIME,
                "match-client-id": False,
                "calculate-tee-times": True,
                "control-socket": {
                    "socket-type": "unix",
                    "socket-name": settings.DHCP_CONTROL_SOCKET_PATH,
                },
                "interfaces-config": {
                    "interfaces": ["*"],
                    "dhcp-socket-type": "udp",
                    "outbound-interface": "use-routing",
                },
                "option-def": [
                    {
                        "name": "no-pxedhcp",
                        "code": 176,
                        "type": "uint8",
                        "array": False,
                        "record-types": "",
                        "space": "ipxe",
                        "encapsulate": "",
                    },
                    {
                        "name": "https",
                        "code": 20,
                        "type": "uint8",
                        "array": False,
                        "record-types": "",
                        "space": "ipxe",
                        "encapsulate": "",
                    },
                ],
                "option-data": [
                    {
                        "name": "domain-name-servers",
                        "data": ", ".join(settings.DHCP_DOMAIN_NAME_SERVERS),
                        "always-send": True,
                    },
                    {
                        "name": "ntp-servers",
                        "data": ", ".join(settings.DHCP_NTP_SERVERS),
                        "always-send": True,
                    },
                    {
                        "name": "no-pxedhcp",
                        "code": 176,
                        "space": "ipxe",
                        "data": "1",
                        "always-send": True,
                    },
                ],
                "next-server": settings.DHCP_NEXT_SERVER,
                "client-classes": [
                    {
                        "name": "ipxe_efi_x86",
                        "test": "option[client-system].hex == 0x0006",
                        "boot-file-name": "ipxe.efi",
                    },
                    {
                        "name": "ipxe_efi_x64",
                        "test": "option[client-system].hex == 0x0007",
                        "boot-file-name": "ipxe.efi",
                    },
                    {
                        "name": "ipxe_efi_x64_x86",
                        "test": "option[client-system].hex == 0x0009",
                        "boot-file-name": "ipxe.efi",
                    },
                    {
                        "name": "ipxe_legacy_x64",
                        "test": "not option[client-system].hex == 0x0006 and not option[client-system].hex == 0x0007 and not option[client-system].hex == 0x0009",  # noqa: E501
                        "boot-file-name": "undionly.kpxe",
                    },
                ],
                "subnet4": list(
                    map(
                        lambda subnet: {
                            "id": subnet.id,
                            "subnet": str(subnet.subnet),
                            "pools": [
                                {
                                    "pool": f"{subnet.allocation_pool_start} - {subnet.allocation_pool_end}"  # noqa: E501
                                }
                            ],
                            "option-data": [
                                {
                                    "name": "domain-name",
                                    "data": (
                                        ""
                                        if subnet.room_set.count() == 0
                                        else (
                                            subnet.room_set.first().domain
                                            if subnet.room_set.count() == 1
                                            else subnet.room_set.first().site.domain
                                        )
                                    ),
                                },
                                {
                                    "name": "routers",
                                    "data": str(subnet.router),
                                },
                            ],
                            "reservations": list(
                                map(
                                    lambda w: {
                                        "hw-address": str(w.machine.mac),
                                        "ip-address": str(w.ip),
                                        "hostname": w.fqdn,
                                    },
                                    Workstation.objects.filter(
                                        room__in=Room.objects.filter(
                                            dhcp_subnet=subnet
                                        ),
                                        machine__isnull=False,
                                    ).select_related("machine", "room"),
                                )
                            ),
                        },
                        DhcpSubnet.objects.all(),
                    )
                ),
                "loggers": [
                    {
                        "name": "kea-dhcp4",
                        "output_options": [
                            {
                                "output": "stdout",
                                "pattern": "%-5p %m\n",
                            },
                        ],
                        "severity": settings.DHCP_LOG_LEVEL,
                        "debuglevel": settings.DHCP_DEBUG_LEVEL,
                    },
                ],
            }
        }

        return JsonResponse(dhcp_config)


class PrometheusServiceDiscovery(View):
    http_method_names = ("get",)

    def get(self, request, *args, **kwargs):
        return JsonResponse(
            list(
                map(
                    lambda workstation: {
                        "targets": [f"{workstation.ip}:9100"],
                        "labels": {
                            "hostname": workstation.name,
                            "room": workstation.room.slug,
                            "site": workstation.room.site.domain,
                        },
                    },
                    Workstation.objects.select_related("room", "room__site")
                    .order_by()
                    .all(),
                )
            ),
            safe=False,
        )


class Registered(TemplateView):
    template_name = "fleet/registered.ipxe"


class Register(TemplateView):
    form_class = RegisterForm
    template_name = "fleet/register.ipxe"
    success_url = reverse_lazy("fleet_registered")

    @method_decorator(csrf_exempt)
    def dispatch(self, *args, **kwargs):
        return super().dispatch(*args, **kwargs)

    def post(self, request, *args, **kwargs):
        form = self.form_class(request.POST)

        try:
            room = Room.objects.get(currently_mapping=True)
        except Room.DoesNotExist:
            form.add_error(None, ValidationError("No room is currently mapping."))

        if not form.is_valid():
            return render(request, self.template_name, {"form": form})

        try:
            workstation = Workstation.objects.get(
                name=form.cleaned_data["name"], room=room
            )
            workstation.switch_name = form.cleaned_data["switch_name"]
            workstation.switch_port = form.cleaned_data["switch_port"]
        except Workstation.DoesNotExist:

fleet/templates/fleet/base.html
{% load static %}
{% load opened_issue_badge %}

<!doctype html>
<html lang="en">

<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">
  <link href="{% static "node_modules/bootstrap/dist/css/bootstrap.min.css" %}" rel="stylesheet">
  <link rel="stylesheet" href="{% static "node_modules/bootstrap-icons/font/bootstrap-icons.css" %}">
  <meta name="theme-color" content="#35479a">

  <title>{% block page_title %}{% endblock %} - Fleet Manager</title>
</head>

<body>
  <nav class="navbar navbar-expand-lg navbar-dark bg-dark">
    <div class="container-fluid">
      <a class="navbar-brand" href="/">
        <div class="d-inline-block align-top">
            {% include 'fleet/logo.svg' %}
        </div>
        &nbsp;Fleet Manager
      </a>
      <button class="navbar-toggler" type="button" data-bs-toggle="collapse" data-bs-target="#navbarSupportedContent"
        aria-controls="navbarSupportedContent" aria-expanded="false" aria-label="Toggle navigation">
        <span class="navbar-toggler-icon"></span>
      </button>

      <div class="collapse navbar-collapse" id="navbarSupportedContent">
        <ul class="navbar-nav me-auto">
          <li class="nav-item">
            <a class="nav-link" href="{% url 'maps' %}">Machine rooms</a>
          </li>
          {% if perms.fleet.view_issue %}
          <li class="nav-item">
            <a class="nav-link" href="{% url 'issues' %}?status=new">
                Issues 
                {% opened_issue_badge request.user %}
            </a>
          </li>
          {% endif %}
          {% if perms.sessions_state.view_session %}
          <li class="nav-item">
            <a class="nav-link" href="{% url 'sessions' %}">Sessions</a>
          </li>
          {% endif %}
        </ul>
        <ul class="navbar-nav ml-auto">
          {% if user.is_authenticated %}
          <li class="nav-item">
            <a href="{% url "user_profile" username=user.username %}" class="btn btn-outline-light mx-1"><i class="bi bi-person-fill"></i>&nbsp;
              {{ request.user.username }}</a>
          </li>
          {% if user.is_staff %}
          <li class="nav-item">
            <a href="{% url 'admin:index' %}" class="btn btn-outline-warning mx-1"><i
                class="bi bi-tools"></i></a>
          </li>
          {% endif %}
          <li class="nav-item">
            <a href="{% url 'logout' %}" class="btn btn-outline-danger mx-1"><i
                class="bi bi-box-arrow-right"></i></a>
          </li>
          {% else %}
          <li class="nav-item">
            <a href="{% url 'social:begin' 'epita' %}" class="btn btn-outline-light mx-1"><i
                class="bi bi-box-arrow-in-right"></i></a>
          </li>
          {% endif %}
        </ul>
      </div>
    </div>
  </nav>
  <div class="pt-5"></div>
  {% if messages %}
  <div class="container">
  {% for message in messages %}
    <div class="alert alert-{{ message.tags }}" role="alert">{{ message }}</div>
  </div>
  {% endfor %}
  <div class="pt-3"></div>
  {% endif %}
  {% block base_content %}
  {% endblock %}
  <script src="{% static "node_modules/jquery/dist/jquery.slim.min.js" %}"></script>
  <script src="{% static "node_modules/bootstrap/dist/js/bootstrap.bundle.min.js" %}"></script>
  <script type="javascript" src="{% static "node_modules/@popperjs/core/dist/umd/popper-base.min.js" %}"></script>
  {% block additional_script %}
  {% endblock %}
</body>
</html>

fleet/templates/fleet/issue-form.html
{% extends 'fleet/base.html' %}
{% load crispy_forms_tags %}

{% block page_title %}Report an issue{% endblock %}

{% block base_content %}
<div class="container">
    <nav aria-label="breadcrumb">
        <ol class="breadcrumb">
            <li class="breadcrumb-item"><a href="{% url 'maps' %}">Home</a></li>
            <li class="breadcrumb-item">Workstations</li>
            <li class="breadcrumb-item">{{ workstation.room.site.name }}</li>
            <li class="breadcrumb-item">{{ workstation.room.name }}</li>
            <li class="breadcrumb-item"><a href="{% url 'workstation_detail' workstation.id %}">{{ workstation.name }}</a></li>
            <li class="breadcrumb-item active" aria-current="page">Report an issue</li>
        </ol>
    </nav>
    <div class="pt-2"></div>
    <h1 class="display-4 flex-grow-1">Report an issue - {{ workstation.name }} - {{ workstation.room.name }} - {{ workstation.room.site.name }}</h1>
    <div class="pt-4"></div>
    <form action="" method="post">
    {% csrf_token %}
    {{ form | crispy }}
      <button type="submit" class="btn btn-primary">Submit</button>
    </form>
</div>
{% endblock %}

fleet/templates/fleet/issue-list.html
{% extends 'fleet/base.html' %}
{% load crispy_forms_tags %}

{% block page_title %}Issues{% endblock %}

{% block base_content %}
<div class="container">
    <nav aria-label="breadcrumb">
        <ol class="breadcrumb">
            <li class="breadcrumb-item"><a href="{% url 'maps' %}">Home</a></li>
        {% if user_profile_page %}
            <li class="breadcrumb-item">Users</li>
            <li class="breadcrumb-item"><a href="{% url 'user_profile' username=profile_username%}">{{ profile_username }}</a></li>
        {% endif %}
            <li class="breadcrumb-item active" aria-current="page">Issues</li>
        </ol>
    </nav>
    <div class="pt-2"></div>
    {% if user_profile_page %}
    {% include "fleet/userprofile-navbar.html" %}
    {% endif %}
    <h1 class="display-4">Issue list</h1>
    <div class="pt-4"></div>
    {% crispy filter.form filter.form.helper %}
    <div class="pt-4"></div>
    <div class="mw-100 overflow-scroll">
    {% include 'fleet/issue-table.html' %}
    </div>
    {% include 'fleet/pagination.html' %}
</div>

{% endblock %}

{% block additional_script %}
<script>
const tooltipTriggerList = document.querySelectorAll('[data-bs-toggle="tooltip"]');
const tooltipList = [...tooltipTriggerList].map(tooltipTriggerEl => new bootstrap.Tooltip(tooltipTriggerEl));
</script>
{% endblock %}

fleet/templates/fleet/issue-table.html
{% load humanize %}

<table class="table table-striped">
    <thead>
        <tr>
            <th class="text-center">Severity</th>
            {% if issues_display_workstation %}
            <th class="text-center">Site</th>
            <th class="text-center">Room</th>
            <th class="text-center">Workstation</th>
            {% endif %}
            <th class="text-center">Problem type</th>
            <th class="text-center">Description</th>
            <th class="text-center">Added by</th>
            <th class="text-center">Added at</th>
            <th class="text-center">Status</th>
            {% if user.is_staff %}
            <th class="text-center">Actions</th>
            {% endif %}
        </tr>
    </thead>
    <tbody>
        {% for issue in issue_list %}
        <tr>
            <td class="text-center" data-bs-toggle="tooltip" title="{{ issue.get_severity_display }}">
            {% if issue.severity == issue.Severity.HIGH %}
                <i class="bi bi-exclamation-octagon-fill text-danger"></i>
            {% elif issue.severity == issue.Severity.MEDIUM %}
                <i class="bi bi-exclamation-triangle-fill text-warning"></i>
            {% elif issue.severity == issue.Severity.LOW %}
                <i class="bi bi-exclamation-square-fill"></i>
            {% elif issue.severity == issue.Severity.UNKNOWN %}
                <i class="bi bi-question-circle-fill text-secondary"></i>
            {% endif %}
            </td>
            {% if issues_display_workstation %}
            <td class="text-center">{{ issue.workstation.room.site.name }}</td>
            <td class="text-center">{{ issue.workstation.room.name }}</td>
            <td class="text-center"><a href="{% url "workstation_detail" issue.workstation.id %}">{{ issue.workstation.name }}</a></td>
            {% endif %}
            <td class="text-center">{{ issue.get_problem_type_display }}</td>
            <td class="text-center">{{ issue.description }}</td>
            <td class="text-center"><a href="{% url "user_profile" issue.added_by %}">{{ issue.added_by }}</a></td>
            <td class="text-center">{{ issue.added_at | naturaltime }}</td>
            <td class="text-center" title="{{ issue.get_status_display }}">
            {% if issue.status == issue.Status.RESOLVED %}
                <span class="badge text-bg-success">{{ issue.get_status_display }}</span>
            {% elif issue.status == issue.Status.NEW %}
                <span class="badge text-bg-warning">{{ issue.get_status_display }}</span>
            {% elif issue.status == issue.Status.REJECTED %}
                <span class="badge text-bg-danger">{{ issue.get_status_display }}</span>
            {% endif %}
            </td>
            {% if user.is_staff %}
            <td class="text-center">
              <div class="d-flex gap-1 justify-content-end">
              {% if issue.status == issue.Status.NEW %}
              <a class="btn btn-success btn-sm" data-bs-toggle="tooltip" title="Resolve" href="{% url 'workstation_issue_resolve' issue.workstation.id issue.id %}"><i class="bi bi-check"></i></a>
              <a class="btn btn-danger btn-sm" data-bs-toggle="tooltip" title="Reject" href="{% url 'workstation_issue_reject' issue.workstation.id issue.id %}"><i class="bi bi-x"></i></a>
              {% endif %}
              {% if issue.status != issue.Status.RESOLVED and issue.status != issue.Status.REJECTED %}
              <a class="btn btn-warning btn-sm" data-bs-toggle="tooltip" title="Edit" href="{% url 'workstation_issue_update' issue.workstation.id issue.id %}"><i class="bi bi-pencil-fill"></i></a>
              {% endif %}
              </div>
            </td>
            {% endif %}
        </tr>
        {% endfor %}
    </tbody>
</table>

fleet/templates/fleet/opened-issue-badge.html
<span class="badge rounded-pill bg-danger">
     {{ opened_issue_count }}
    <span class="visually-hidden">opened issues</span>
</span>

fleet/templates/fleet/pagination.html
{% load query_transform %}
<ul class="pagination justify-content-center">
  <li class="page-item {% if not page_obj.has_previous %}disabled{% endif %}">
    <a class="page-link" {% if page_obj.has_previous %}href="?{% query_transform page=page_obj.previous_page_number %}"{% endif %}
      aria-label="Previous">
      <span aria-hidden="true">&laquo;</span>
    </a>
  </li>

  {% for page_number in paginator_range %}
  <li class="page-item {% if page_number == page_obj.paginator.ELLIPSIS %}disabled{% endif %}{% if page_number == page_obj.number %}active{% endif %}" aria-current="page">
    <a class="page-link" href="?{% query_transform page=page_number %}">{{ page_number }}</a>
  </li>
  {% endfor %}

  <li class="page-item {% if not page_obj.has_next %}disabled{% endif %}">
    <a class="page-link" {% if page_obj.has_next %}href="?{% query_transform page=page_obj.next_page_number %}"{% endif %}
      aria-label="Next">
      <span aria-hidden="true">&raquo;</span>
    </a>
  </li>
</ul>

fleet/templates/fleet/room-map.html
<div class="card h-100 justify-content-between shadow-sm">
{% if svg %}
  <div class="card-img-top p-3 overflow-scroll">
    <div class="d-xl-flex justify-content-center w-100">
      {{ svg | safe }}
    </div>
  </div>
  <div class="flex-grow-1"></div>
{% endif %}
  <div class="card-body flex-grow-0">
    <h5 class="card-title">{{ object.site.name }} - {{ object.name }}</h5>
    <div>
      <div>
          Used machines <span class="badge text-bg-secondary">{{ used_machines }}</span>
      </div>
      <div>
        Total machines <span class="badge text-bg-secondary">{{ object.workstation_set.count }}</span>
      </div>
      <div>
        Number of issues reported <span class="badge text-bg-secondary">{{ issue_count }}</span>
      </div>
    </div>
  </div>
</div>

fleet/templates/fleet/session-table.html
  <table class="table table-striped">
      <thead>
          <tr>
              {% if session_display_ip %}
              <th class="text-center">IP</th>
              {% endif %}
              {% if session_display_login %}
              <th class="text-center">Login</th>
              {% endif %}
              <th class="text-center">Image</th>
              <th class="text-center">Start</th>
              <th class="text-center">End</th>
          </tr>
      </thead>
      <tbody>
          {% for session in session_list %}
          <tr>
              {% if session_display_ip %}
              <td class="text-center">{{ session.ip }}</td>
              {% endif %}
              {% if session_display_login %}
              <td class="text-center"><a href="{% url "user_profile" session.login %}">{{ session.login }}</a></td>
              {% endif %}
              <td class="text-center">{{ session.image }}</td>
              <td class="text-center">{{ session.interval.lower }}</td>
              <td class="text-center">{{ session.interval.upper }}</td>
          </tr>
          {% endfor %}
      </tbody>
  </table>

fleet/templates/fleet/workstation-map-popover.html
{% if sessions %}
{% if admin_view %}
<p>Connected users:</p>
<ul>
{% regroup sessions by login as login_list %}
  {% for u, user_session_list in login_list %}
  <li><strong>{{ u }}</strong>{% with last_s=user_session_list|last %}{% if last_s.locked %} (locked){% endif %}{% endwith %}</li>
  {% endfor %}
</ul>
<p>Image: <strong>{% with last_s=sessions|last %}{{ last_s.image }}{% endwith %}</strong></p>
{% else %}
<p>Someone is connected.</p>
{% endif %}
{% else %}
<p>No one is connected.</p>
{% endif %}
{% if issues %}
<p>Issues:</p>
<ul>
  {% for i in issues %}
  <li>{{ i.description }}</li>
  {% endfor %}
</ul>
{% else %}
<p>No issue reported.</p>
{% endif %}